package xyz.lychee.lagfixer.libs.adventure.audience;

import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Consumer;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import xyz.lychee.lagfixer.libs.adventure.resource.ResourcePackCallback;
import xyz.lychee.lagfixer.libs.adventure.text.ComponentLike;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public final class Audiences {
   static final Collector<? super Audience, ?, ForwardingAudience> COLLECTOR = Collectors.collectingAndThen(Collectors.toCollection(ArrayList::new), (audiences) -> {
      return Audience.audience((Iterable)Collections.unmodifiableCollection(audiences));
   });

   private Audiences() {
   }

   public static @NotNull Consumer<? super Audience> sendingMessage(final @NotNull ComponentLike message) {
      return (audience) -> {
         audience.sendMessage(message);
      };
   }

   static @NotNull ResourcePackCallback unwrapCallback(final Audience forwarding, final Audience dest, final @NotNull ResourcePackCallback cb) {
      return cb == ResourcePackCallback.noOp() ? cb : (uuid, status, audience) -> {
         cb.packEventReceived(uuid, status, audience == dest ? forwarding : audience);
      };
   }
}
